<template>
    <div id="here">
        
        <div v-if="alertText" :class="alertClasses" role="alert">
             <button type="button" class="close" @click="closeAlert"><span aria-hidden="true">×</span></button>
            <strong>{{ alertText }}</strong>
        </div>
        <div class="white-box" v-if="showForm">
            <h3 class="box-title text-success m-b-30" v-if="formCreating">CREATE NEW STUDENT STRENGTH</h3>
            <h3 class="box-title text-success m-b-30" v-else>UPDATE STUDENT STRENGTH</h3>
            <hr/>
                <!-- <div class="col-md-3">
                    <div class="form-group">
                        <label class="control-label">Select Year to Filter</label>
                        <input type="text" id="firstName" class="form-control" name="quantity">
                    </div>
                </div> -->
                <form v-on:submit.prevent = "saveStudent"  method="post" enctype="multipart/form-data">
                    
                    <div class="row">
                        <div class="col-md-4">
                            <div class="form-group">
                                <label class="control-label">Year<span class="text-danger">*</span></label>
                                <input type="text" id="firstName" class="form-control" name="year" v-model="formData.year" required>
                            </div>
                        </div>
                    
                        <div class="col-md-4">
                            <div class="form-group">
                                <label class="control-label">Classes<span class="text-danger">*</span></label>
                                <select class="form-control" data-placeholder="Choose a Category" tabindex="1" name="class" v-model="formData.classId" required>
                                    <option value="">--Select Class--</option>
                                    
                                    <option v-for="our_class in classes" :value="our_class.id">{{ our_class.name }} [{{ our_class.academic_version }}]</option>
                                    
                                </select>
                            </div>
                        </div>

                        <div class="col-md-4">
                            <div class="form-group">
                                <label class="control-label">Number of Students<span class="text-danger">*</span></label>
                                <input type="text" id="firstName" class="form-control" name="students" v-model="formData.numberOfStudent" required min="1">
                            </div>
                        </div>
                    </div>
                    <div class="form-group text-right">
                        <button type="button" class="btn btn-default" @click="onCancel">Cancel</button>
                        <button type="submit" class="btn btn-success" v-if="formCreating"> <i class="fa fa-check"></i> Save</button>
                        <button type="submit" class="btn btn-success" v-else> <i class="fa fa-check"></i> Update Student Strength Info</button>
                    </div>
                </form>


        </div>
        <div class="white-box">
            <h3 class="box-title text-success" style="margin-bottom : 50px">STUDENT STRENGTH LISTS
                <button type="button" class="btn btn-info btn-sm flat pull-right" @click="onCreateClick" v-if="!showForm">
                    <i class="fa fa-plus-circle"></i> CREATE NEW STUDENT STRENGTH</button>
            </h3>
            <hr/>
            <table class="table table-bordered table-striped" id="product-table">
                <thead>
                <tr>
                    <th>SL</th>
                    <th>Year</th>
                    <th>Class</th>
                    <th>Number of Student</th>
                    <th>Action</th>
                </tr>
                </thead>
                <tbody>
                    <tr v-for="(student,index) in students">
                        <td>{{ index+1 }}</td>
                        <td>{{ student.year }}</td>
                        <td>{{ student.student_class.name }} [{{ student.student_class.academic_version }}]</td>
                        <td>{{ student.quantity }}</td>
                        <td style="text-align:center">
                            <button class="btn btn-warning btn-sm flat" v-scroll-to="'#here'" @click="selectStudent(index)"><i class="fa fa-edit"></i> Update</button>
                            <button class="btn btn-danger btn-sm flat" @click="deleteItem(index)"><i class="fa fa-bomb"></i> Delete</button>
                        </td>
                    </tr>
                </tbody>
            </table>
                
            </div>
     </div>
    
</template>

<script>

    export default {
        props: [
            'all_students'
        ],
        data: function(){
            return  {
               students: [],
               showForm: false,
               classes: [],
               formData: {
                    year: "",
                    numberOfStudent: 0,
                    classId: ""
                    
                },
                alertClasses: 'alert alert-success fade in',
                alertText: null,
                formCreating: true,
                editId : null,
                editIndex : null
            }        
        },
        methods: {
            onYear: function(){
              
            },
            onCreateClick: function(){
                this.showForm = true;
                this.closeAlert();
            },
            onCancel: function(){
                this.showForm = false;
                this.formCreating = true;
                this.closeAlert();
            },
            selectStudent: function(index){
                console.log("hello from edit");
                let student = this.students[index];
                this.formData.classId= student.class_id;
                this.formData.year = student.year;
                this.formData.numberOfStudent = student.quantity;
                this.formCreating = false;
                this.showForm = true;
                this.editId = student.id;
                this.editIndex = index;
                console.log(index + " " + student.id);
            },
            saveStudent: function(){
                if(this.formCreating){
                    this.saveData();
                }else{
                    //console.log(this.formData);
                    this.update();
                }
                
            },
            saveData: function(){
                var app =this;
                axios.post('wirehouse/save-students' ,app.formData)
                    .then(result => {
                        app.alertText = result.data.message;
                        console.log(result.data);
                        if(result.data.status == 'exist'){
                            app.alertClasses = "alert alert-warning fade in";
                        }else{
                            //console.log("hello fr om");
                            app.students.splice(0,0,result.data.student);
                            //app.getNewData();
                            app.resetForm();
                        }

                        //app.findStudents();

                        
                    })
                    .catch(e => {
                        this.errors.push(e)
                    });

                return false;
            },
            resetForm: function(){
                app.formData.year = "";
                app.formData.classId = "";
                app.formData.numberOfStudent = 0;
            },
            deleteItem: function(index){
                 var r = confirm("Are you sure want to delete this information?");
                    if (r == true) {
                       let student = this.students[index];
                            this.editId = student.id;
                            this.editIndex = index;
                            var app = this;
                            axios.get('wirehouse/delete_item/'+app.editId)
                                .then(result => {
                                    app.alertText = result.data.message;
                                    app.students.splice(index,1);
                                })
                    }
            },
            update: function(){
                
                var app =this;
                //console.log(this.formData);
                //return;

                axios.post('wirehouse/update-students/' + app.editId,app.formData )
                    .then(result => {
                        app.alertText = result.data.message;
                        if(result.data.status == 'failed'){
                            app.alertClasses = "alert alert-danger fade in";
                        }else{
                            console.log(result.data);
                            app.students.splice(app.editIndex,1,result.data.new_student);
                            app.formCreating = true;
                            app.showForm = false;
                            app.formData.year = "";
                            app.formData.classId = "";
                            app.formData.numberOfStudent = 0;
                        }
                    })
                    .catch(e => {
                        this.errors.push(e)
                    });
            },
            getNewData: function(){
                axios.get('wirehouse/show_new_strength')
                        .then(result => {
                            //console.log(result.data.students);
                            
                            this.students = null;
                            this.students = result.data.students;
                            return;
                        })
            },
            closeAlert: function(){
                    this.alertText = null;
                    this.alertClasses = 'alert alert-success fade in';
            } 
        },
        created: function() {
            this.students = this.all_students.stu;
            this.classes = this.all_students.our_class;
        },        


    };

</script>